/*COMLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#define		HUGE	9999
#ifdef	CAN_PROTO
extern int range(int,char *);
extern char *strget(char *,char *,char *,char *);
#else
extern char *strget();
extern int range();
#endif
/*EXTERN*/
extern	KENV	kenv;
char	*
strget(os,us,is,fm)
char	*os;	/* output */
char	*us;	/* upper limit _us */
char	*is;	/* input */
char	*fm;	/* format */
{
	REG		char	*fmx = fm;
	REG		char	*isx = is;
	REG		char	*osx = os;
	REG		char	*usx = us;
	REG		char	*svx = NULL;
	REG		int		nrx;
	if(isnull(is))	return(NULL);
	while(*fmx != ZERO)		{
/**/
		if(isspace(*fmx))	{
			fmx += 1;
			while(isspace(*isx))	++isx;
			}
/**/
		else
		if(*fmx == '%')		{
/**/
			if(svx)		osx = svx;
/**/
			if(*++fmx == '*')	{
				svx = osx;
				fmx += 1;
				}
			else	svx = NULL;
/**/
			nrx = atoi(fmx);
			nrx = nrx ? nrx : HUGE;
			while(isdigit(*fmx))	++fmx;
/**/
			switch(*fmx++)	{
				case	'[':
					while(osx < usx && nrx-- >= 1 && range(*isx,fmx))
						*osx++ = *isx++;
					if(svx)	osx = svx;
					*osx = ZERO;
					return(isx);
				case	'%':		
					*osx++ = '%';
					break;
				case	'S':
				case	's':
					while(osx < usx && nrx-- >= 1)
						if(isspace(*isx))	break;
						else
						if(isprint(*isx))	*osx++ = *isx++;
						else				break;
					break;
				case	'F':
				case	'f':
					while(osx < usx && nrx-- >= 1)
						if(isdigit(*isx))	*osx++ = *isx++;
						else
						if(*isx == '-')		*osx++ = *isx++;
						else
						if(*isx == '.')		*osx++ = *isx++;
						else				break;
					break;
				case	'N':
				case	'n':
					while(osx < usx && nrx-- >= 1)
						if(isalnum(*isx))	*osx++ = *isx++;
						else				break;
					break;
				case	'A':
				case	'a':
					while(osx < usx && nrx-- >= 1)
						if(isalpha(*isx))	*osx++ = *isx++;
						else				break;
					break;
				case	'D':
				case	'd':
					while(osx < usx && nrx-- >= 1)
						if(isdigit(*isx))	*osx++ = *isx++;
						else				break;
					break;
				case	'L':
				case	'l':
					while(osx < usx && nrx-- >= 1)
						if(islower(*isx))	*osx++ = *isx++;
						else				break;
					break;
				case	'U':
				case	'u':
					while(osx < usx && nrx-- >= 1)
						if(isupper(*isx))	*osx++ = *isx++;
						else				break;
					break;
				}
			}
		else
		if(*fmx == *isx)	{
			++isx;
			++fmx;
			}
		else				break;
	}
	if(svx)	osx = svx;
	*osx = ZERO;
	return(isx);
}
#ifdef		STRDOC
%[set]	next characters in set
%[^set]	next characters not in set
%s		until next white space
%f		floating point number
%a 		next alphabetic
%d		next digits
%l		next lower case
%u		next upper case
%*		suppress following format
#endif		STRDOC
