/*COMLIB*/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include	"ksysprot.h"
#include	"ksysansi.h"
/**/
tansi(fp,ty,yy,xx)
FILE	*fp;
int	ty;
int	yy;
int	xx;
{
	switch(ty)	{
	case	TCD:	fprintf(fp,"\033[%dJ",yy);
	when	TCE:	fprintf(fp,"\033[%dK",yy);
	when	TSF:	fprintf(fp,"\033[%dS",yy);
	when	TSR:	fprintf(fp,"\033[%dT",yy);
	when	TCM:	fprintf(fp,"\033[%d;%dH",yy,xx);
	when	TUP:	fprintf(fp,"\033[%dA",yy);
	when	TDO:	fprintf(fp,"\033[%dB",yy);
	when	TND:	fprintf(fp,"\033[%dC",yy);
	when	TBS:	fprintf(fp,"\033[%dD",yy);
	when	TAL:	fprintf(fp,"\033[%dL",yy);
	when	TIC:	fprintf(fp,"\033[%d@",yy);
	when	TDL:	fprintf(fp,"\033[%dM",yy);
	when	TDC:	fprintf(fp,"\033[%dP",yy);
	when	TRS:	fprintf(fp,"\033[0m");
	when	TBO:	fprintf(fp,"\033[1m");
	when	TUL:	fprintf(fp,"\033[4m");
	when	TBL:	fprintf(fp,"\033[5m");
	when	TRV:	fprintf(fp,"\033[7m");
					break;
	default:		dump("tansi: ty");
					break;
	}
	fflush(fp);
	return(0);
}
/**/
#ifdef	TEST
KENV	kenv;
main()
{
	auto	char	ls[BLKSIZ];
	auto	int	pr = 0;
	auto	int	nx = 0;
	auto	int	ny = 0;
	disnme(kenv.pname = "tester");
	while(fgetlf(ls,ls+BLKSIZ-1,stdin))		{
	switch(ls[0])	{
	case	'!':	system(ls+1);
	when	'C':	tansi(stdout,TCD,atoi(ls+1));
	when	'E':	tansi(stdout,TCE,atoi(ls+1));
	when	'F':	tansi(stdout,TSF,atoi(ls+1));
	when	'B':	tansi(stdout,TSR,atoi(ls+1));
	when	'U':	tansi(stdout,TUP,atoi(ls+1));
	when	'D':	tansi(stdout,TDO,atoi(ls+1));
	when	'N':	tansi(stdout,TND,atoi(ls+1));
	when	'H':	tansi(stdout,TBS,atoi(ls+1));
	when	'M':	sscanf(ls+1,"%d %d",&ny,&nx);
					tansi(stdout,TCM,ny,nx);
	when	'L':	tansi(stdout,TAL,atoi(ls+1));
	when	'I':	tansi(stdout,TIC,atoi(ls+1));
	when	'd':	tansi(stdout,TDL,atoi(ls+1));
	when	'c':	tansi(stdout,TDC,atoi(ls+1));
	when	'b':	tansi(stdout,TBO);
	when	'u':	tansi(stdout,TUL);
	when	'f':	tansi(stdout,TBL);
	when	'r':	tansi(stdout,TRV);
	when	'x':	tansi(stdout,TRS);
					break;
	default:		puts("\007?????\007");
					break;
	}
	}
	exit(0);
}
#endif
