/*
	defines used by ked
*/
#define		ADDBEG		1
#define		ADDEND		2
#define		ADDCLS		4
#define		TERSE		1
#define		VERBOSE		0
#define		LINE_IO		0
#define		CARD_IO		1
#define		JOIN_OO		'o'
#define		JOIN_SO		's'
#define		JOIN_AO		'a'
#define		MAXBUF		BUFSIZ * 2
#define		MAXCARDS	BUFSIZ * 2
#define		BCLS		1
#define		BRDD		2
#define		BREC		4
#define		BREM		8
#define		BSET		16
#define		BSIZ		32
#define		BWRT		64
#define		BPRE		128
#define		MARKCARD	DA
/*
	pseudo functions
*/
#define     roundup(a,b)(a + (b - (a % b)))
#define     flop(x)((x >= 1) ? 0 : 1)
/*	
	structure/union definitions
*/
/**/
typedef	struct	UNDOBUF	{
	long	header;		/* start for this structure */
	long	magic;		/* buffer date as long */
	long	cbtsiz;		/* size of cbt array in bytes */
	long	editfn;		/* beginning of file name */
	long	cdxbuf[2];	/* beginning of cdx structure */
	long	cbtbuf[2];	/* cbt buffer */
	long	ebufl[2];	/* address of edcd undo */
	long	addbuf[2];	/* append begin and end */
	long	utime[2];	/* time of last undo write */
	long	lastloc;	/* last location used */
	int		elatch;		/* toggle for edcd undo */
	int		ulatch;		/* toggle for undo */
	int		canund;		/* safe to undo */
	int		recovr;		/* recovery switch */
}	UNDOBUF;
typedef	struct	CDACT {
	int		 glb;		
	int		 del;	
	int		 max;
	int		 chg;
	int		 nn1;
	int		 nn2;
	int		 act;
	int		 sve;
	int		 cur;
	int		 lst;
	int		 con;
}	CDACT;
