#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "keddefs.h"
#include	"kedvars.h"
#include	"ksysprot.h"
#include	"kedfuncs.h"
#include	"kedbuffr.h"
/**/
#define	toalpha(a)(a + '\140')
#define	tomarks(a)(a - '\140')
/*EXTERN*/
extern	void	dolerr();
extern	void	domark();
extern	int		gtmark();
/**/
void
domark(n1,n2,is)	/* place or display marks */
int		n1;			/* place mark here */
int		n2;			/* not used */
char	*is;		/* command string */
{
	auto	int		cx;
	auto	NOSIGN	mark;
	auto	NOSIGN	ix;
	while(isspace(*is))	++is;
	cx = *is;
/*	DISPLAY MARKS */
	if(cx == ZERO)	{
		auto	NOSIGN	count = 0;
		for(ix = 1; ix < cdx.lst; ix++)	{
			if(cbt[ix].tags.mark)	{
				count += 1;
				printff("%c %u\n",toalpha(cbt[ix].tags.mark),ix);
				}
			}
		if(!count)	printf("<no marks set>\n");
		return;
		}
/**/
	if(!isalpha(cx))	{
		errmsg("domark <illegal mark> '%c'\n",cx);
		terror(FUBAR);
		return;
		}
/**/
	if(isupper(cx))	cx = tolower(cx);
	mark = tomarks(cx);
/**/
/*		CLEAR PREVIOUS MARK */
	for(ix = 1; ix < cdx.lst; ix++)	{
		if(cbt[ix].tags.mark == mark)	{
			cbt[ix].tags.mark = 0;
			}
		}
/*	SET MARK AT DOT */
	cbx = cbt + n1;
	cbx->tags.mark = mark;
	/* cbt[n1].tags.mark = mark; */
	return;
/**/
}
gtmark(cx)	/* return the card number of a marked card */
int		cx;	/* mark character */
{
	auto	NOSIGN	ix;
	auto	NOSIGN	mark;
/**/
	if(!isalpha(cx))	{
		errmsg("domark <illegal mark> '%c'\n",cx);
		terror(FUBAR);
		return(-1);
		}
/**/
	if(isupper(cx))	cx = tolower(cx);
	mark = tomarks(cx);
	for(ix = 1; ix <= cdx.lst; ix++)	{
		if(cbt[ix].tags.mark == mark)	return(ix);
		}
/**/
	errmsg("gtmark <undefined mark> '%c'\n",cx);
	return(-1);
}
/**/
