#define		DEBUG
#undef		DEBUG
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"ksyskref.h"
#define		NO_DUPE
/*EXTERN*/
/**/
char	*
bufrset(nc)
int	nc;
{
	if(bufo)	free_if(bufo);
	bufc = bufu = bufo = emalloc(nc,"bullset");
	memset(bufc,0,nc);
	bufu = bufo + nc;
	return(bufo);
}
/**/
BS *
bullset(nc)		/* create the ".bs" list table */
int		nc;
{
	auto	NOSIGN	size = sizeof(BS) * nc;
	bsc = bso = bsu = (BS *) free_if( (char *) bso);
	bsc = bso = (BS *) emalloc( size , "bullset" );
	bsu = bso + nc;
	memset( (char *) bso, 0, size );
	return(bso);
}
BS	*
addbs(is,ln,fn)			/* add a ".bs" entry */
char	*is;			/* raw ".bs" line */
NOSIGN	ln;				/* line number */
char	*fn;
{
	auto	char	ws[KEYSIZ];
	REG		BS		*bsx = bso;
	auto	char	*bse;
/*
	assume that the ".bs" or whatever is NOT passed
*/
	bse = strrchr(is,'/');
/*
**	in the note mode, the separator is set to a blank so that
**	the page number is treated as a word and acts in the search
**	patterns.
*/
	if(bse)	{
		if(kenv.buffer & DA)	*bse = ' ';
		else					*bse = ZERO;
		}
/**/
	kpc(ws,ws+KEYSIZ-1,is);
#ifdef	DEBUG
	prpat(ws,stderr);
	query(stderr);
#endif	/*DEBUG*/
	if(isnull(ws))	{
		errmsg("addbs <null pattern> %u in %s\n",ln,fn);
		return(bsc = bsx);
		}
	while(bsx->bs)	{
		if(kpx(ws,bsx->bs))	return(bsx);
		else				bsx += 1;
		}
	bsx->bs = strsave(ws);
	if(bsx >= bsu)	{
		errmsg("addbs <too much bs>\n");
		terror(FUBAR);
		}
/**/
	return(bsc = bsx);
}
