#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#define		ALLOCATE
#include	"ksyskwik.h"
#include	"kwikhash.h"
#include	<fcntl.h>
#ifdef	__MSDOS__
#include	<io.h>
#endif	/*__MSDOS__*/
#define		KWIKFIND	"kwikfind.ind"
#define		PAGESIZ		16384
#define		BIGBUF		8192
#undef		GRANULE
#define		GRANULE		16
typedef unsigned long ULONG;
typedef	int HANDLE;
typedef struct BARF {
	char	*base;
	char	*bmax;
	char	*buse;
	}	BARF;
typedef struct TNODE {
	char	*word;
	struct	TNODE	*left;
	struct	TNODE	*rite;
	}	TNODE;
TNODE	*root = (TNODE *) NULL;
USHORT	files;
USHORT	granu;
USHORT	block;
USHORT	words;
USHORT	cards;
DADR	addr;
BARF	kz;
/*EXTERN*/
#ifdef	CAN_PROTO
extern long atol(char *);
extern char *skipdigit(char *);
extern char *strvowel(char *);
extern TNODE *talloc(void);
extern void treeprint(TNODE *);
extern TNODE *tree(TNODE *,char *);
extern void headprint(USHORT,DADR,USHORT,USHORT);
#else	/*CAN_PROTO*/
extern char *skipdigit();
extern char *strvowel();
extern TNODE *talloc();
extern void treeprint();
extern TNODE *tree();
extern void headprint();
extern long atol();
#endif	/*CAN_PROTO*/
void
terror(ty)
int		ty;
{
	xwrcd(kz.base,stderr);
	exit(ty);
}
main(argc,argv)
int		argc;
char	*argv[];
{
	kenv.dosdos = isdos();
	kz.base = emalloc(4096,"main");
	kz.bmax = kz.base + 4096;
	modfac = 4091;
	granu = cmdnum(argc,argv,'G',8,8);
	kenv.flags0 = cmdnum(argc,argv,'C',0,1);
	kenv.flags1 = cmdnum(argc,argv,'R',0,1);
	kenv.flags2 = cmdnum(argc,argv,'V',0,1);
	kenv.flags3 = cmdnum(argc,argv,'S',0,1);
	rdfunc = xrdcd;
	rfn = cmdlist(argc,argv,ZERO,NULL);
	ksetvbuf(stderr,NULL,_IOLBF,BUFSIZ);
	xfn = "biblbibl.tmp";
	doterm();
	exit(0);
}
doterm()
{
	auto	char	ls[FNMSIZ];
	while(putchar('?'),fflush(stdout),gets(ls))	{
		switch(ls[0])	{
			case	'X':	dofiles( rfn );
							break;
			case	'q':	exit(0);
			case	'!':	system(ls+1);
							break;
			case	'/':	findword(ls+1);
							break;
			default:		
							fputs("?????\n",stdout);
							break;
			}
		}
}
findword(is)
char	*is;
{
	auto	char	os[FNMSIZ];
	auto	char	ls[FNMSIZ];
	auto	USHORT	numbr;
	static	char	*xfb = NULL;
	static	char	*rfb = NULL;
	auto	char	*lsx;
	xfp = xfclose( xfp );
	rfp = xfclose( rfp );
	xfp = tefopen( xfn, kenv.dosdos ? "rb" : "r" );
	xfb = free_if( xfb );
	rfb = free_if( rfb );
	xfb = ksetvbuf(xfp,xfb,_IOFBF,BIGBUF);
	kpc(os,os+FNMSIZ-1,is);
	rdheadr();
	while(fgetls(ls,ls+FNMSIZ-1,xfp))	{
		files = atol(lsx = ls);
		addr = atol(lsx = skipdigit(lsx));
		cards = atol(lsx = skipdigit(lsx));
		words = atol(lsx = skipdigit(lsx));
		numbr = granu;
		kz.buse = kz.base;
		if(words == 0)	break;
/**/
		while(words-- && fgetls(ls,ls+FNMSIZ-1,xfp))	{
			kz.buse = strkat(kz.buse,kz.bmax,ls);
			kz.buse = strkat(kz.buse,kz.bmax," ");
			}
		kz.buse += 1;
		kpc(kz.buse, kz.bmax, kz.base);
		if(kpx(kz.buse,os))	{
			rfp = tefopen( rfn, kenv.dosdos ? "rb" : "r" );
			rfb = ksetvbuf(rfp,rfb,_IOFBF,BIGBUF);
			efseek( rfp, addr, 0 );
			while(numbr-- && (kz.buse = xrdcd( kz.base, kz.bmax, rfp )))	{
				kz.buse += 1;
				kpc(kz.buse, kz.bmax, kz.base);
				if(kpx( kz.buse, os ))	{
					xwrcd( kz.base, stdout );
					fputs("\r\n",stdout);
					fflush( stdout );
					if(query(stderr) == 'q')	{
						rfp = xfclose( rfp );
						xfp = xfclose( xfp );
						xfb = free_if( xfb );
						rfb = free_if( rfb );
						return( 0 );
						}
					}
				}
			rfp = xfclose( rfp );
			rfb = free_if( rfb );
			}
		}
	rfp = xfclose( rfp );
	rfb = free_if( rfb );
	return( 0 );
}
chkfiles(is)	/* check for read permission */
char	*is;
{
	auto	char	ws[FNMSIZ];
	auto	FILE	*fp;
	auto	USHORT	er = 0;
	strxty(is,',',' ');
	strcnd(is);
#ifdef	__MSDOS__
	strlwr(is);
	strxty(is,'\\','/');
#endif	__MSDOS__
	while( (int) (is = xgnc(ws,ws+FNMSIZ-1,is,' ')))	{
		fp = efopen(ws,kenv.dosdos ? "rb" : "r" );
		if(fp == NULL)	er += 1;
		fp = xfclose(fp);
		}
	return(er);
}
rdheadr(is)
char	*is;
{
	auto	char	ls[FNMSIZ];
	auto	char	fn[FNMSIZ];
	auto	int		loop = 1;
	rewind( xfp );
	rfn = free_if( rfn );
	while(loop && fgetls(ls,ls+FNMSIZ-1,xfp))	{
		switch(ls[0])	{
			case	'F':
				strcpy(fn,ls + 2);
				rfn = stradd( rfn, fn );
				break;
			case	'H':	
				break;
			case	'X':
				loop = 0;
				break;
			default:	
				dump("<header error>");
				break;
			}
		}
}
wrheadr(is)
char	*is;
{
	auto	char	ws[FNMSIZ];
	fprintf(xfp,"H\n");
	while(is = xgnc(ws,ws+FNMSIZ-1,is,' '))	{
		fprintf(xfp,"F %s\n",ws);
		}
	fprintf(xfp,"X\n");
}
dofiles(is)		/* loop through files */
char	*is;
{
	static	char	*here = "dofiles";
	auto	char	ws[FNMSIZ];
	auto	FILE	*fp;
/**/
	xfp = tefopen( xfn, kenv.dosdos ? "w+b" : "w+" );
/**/
	if(chkfiles(is))	terror(FUBAR);
/**/
	wrheadr( rfn );
/**/
	words = block = files = cards = 0;
/**/
	while((int) (is = xgnc(ws,ws+FNMSIZ-1,is,' ')))	{
		fp = tefopen(ws,kenv.dosdos ? "rb" : "r" );
		cards += xonefile(fp,files,granu);
		fp = xfclose(fp);
		files += 1;
		}
/**/
	return(files);
}
xonefile(fp,files,granu)
FILE	*fp;
USHORT	files;
USHORT	granu;
{
	auto	DADR	addr = 0L;
	auto	char	word[FNMSIZ];
	auto	char	*bufx;
	auto	USHORT	cards = 0;
/**/
	addr = ftell(fp);
	while(1)	{
		if(!(*rdfunc) (bufx = kz.base,kz.bmax,fp))		break;
/**/
		cards += 1;
/**/
		zapkeys(bufx);
/**/
		while((int) (bufx = xgnw(word,word+MAXWORD-1,bufx)))	{
			if(kenv.flags2)			strvowel(word);
			if(strlen(word) <= 2)	continue;
			if(strmix(word))		continue;
			if(kenv.flags1)			strrev( word );
			root = tree( root, word );
		}
		if(cards % granu == 0)	{
			headprint( files, addr, cards, words);
			treeprint( root );
			addr = ftell(fp);
			root = (TNODE *) NULL;
			words = 0;
			}
	}
/**/
	headprint( files, addr, cards, words);
	treeprint( root );
	addr = ftell(fp);
	root = (TNODE *) NULL;
	words = 0;
/**/
	return(cards);
}
void
headprint(files,addr,cards,words)
USHORT	files;
DADR	addr;
USHORT	cards;
USHORT	words;
{
	fprintf(xfp,"%u %lu %u %u\n",files,addr,cards,words);
	fprintf(stderr,"%u %lu %u %u\r",files,addr,cards,words);
	return;
}
char    *
zapkeys(is)		/* remove keys from ked card */
char    *is;
{
	REG     char    *isx = is;
	REG     char    *osx = is;
	while(*isx != ZERO)     {
		while(isalnum(*isx))    ++isx;
		while(isspace(*isx))    ++isx;
		while(*isx != ZERO && *isx != LF)       *osx++ = *isx++;
		if(*isx == LF)                          *osx++ = *isx++;
	}
	*osx = ZERO;
	return(is);
}
char    *
xgnw(os,us,is)		/* get next word */
char    *os;
char    *us;
char    *is;
{
	REG             char    *osx = os;
	REG             char    *usx = us;
	REG             char    *isx = is;
/**/
	while(*isx != ZERO && isspace(*isx))    ++isx;
/**/
	if(isnull(isx))	return(NULL);
/**/
	while(*isx != ZERO && osx < usx && !isspace(*isx))	{
		if(islower(*isx))	{ *osx++ = *isx++; }
		else
		if(isupper(*isx))	{ *osx++ = tolower(*isx); ++isx; }
		else
		if(isalnum(*isx))	{ *osx++ = *isx++; }
		else				{ isx += 1; }
		}
/**/
	*osx = ZERO;
/**/
	return(isx);
}
long
elseek(fd,ad,ty)
int		fd;
long	ad;
int		ty;
{
	extern	long	lseek();
	auto	long	rt = lseek(fd,ad,ty);
	if(rt < 0L)	{
		perror("lseek");
		}
	return( rt );
}
void
where(is)
char	*is;
{
	fputs(is,stderr);
	fputs(" ",stderr);
	return;
}
HANDLE
eopen(is,mo)
char	*is;
int		mo;
{
	auto	HANDLE	fd = open(is,mo);
	if(fd < 0)	{
		perror(is);
		terror(FUBAR);
		}
	return(fd);
}
HANDLE
eclose(fd)
HANDLE	fd;
{
	auto	HANDLE	rt = close(fd);
	if(rt)	perror("eclose");
	return(rt);
}
ewrite(fd,buf,nc)
HANDLE	fd;
char	*buf;
int		nc;
{
	auto	int		nr = write( fd, buf, nc);
	if(nr < 0 || nr != nc)	perror("eread");
	return(nr);
}
eread(fd,buf,nc)
HANDLE	fd;
char	*buf;
int		nc;
{
	auto	int		nr = read( fd, buf, nc);
	if(nr < 0)	perror("eread");
	return(nr);
}
estat(is,sb)		/* stat call with error message */
char	*is;
STAT	*sb;
{
	auto	int		rt = stat(is,sb);
	static	char	*here = "estat";
	if(rt)	{
		where(here);
		prterr("<%s>",is);
		}
	return(rt);
}
strmix(is)
char	*is;
{
	REG		char	*isx = is;
	while(*isx != 0)
	if(isdigit(*isx))	return(*isx);
	else				isx += 1;
	return(0);
}
TNODE	*
tree(p,w)
TNODE	*p;
char	*w;
{
	extern	TNODE	*talloc();
	auto	int		cond;
	if(p == NULL)	{
		p = talloc();
		p->word = strsave(w);
		p->left = p->rite = (TNODE *) NULL;
		words += 1;
		}
	else
	if((cond = strcmp(w,p->word)) == 0)	;
	else
	if(cond < 0)	p->left = tree(p->left,w);
	else			p->rite = tree(p->rite,w);
	return(p);
}
void
treeprint(p)
TNODE	*p;
{
	if(p != (TNODE *) NULL)	{
		treeprint(p->left);
		if(kenv.flags3)	checkwrite(xfp,p->word);
		else
		if(kenv.flags0) shortwrite(xfp,p->word);
		else 			{ fputs(p->word,xfp); fputs("\n",xfp); }
		p->word = free_if(p->word);
		treeprint(p->rite);
		p = free_if( (char *) p);
		}
}
TNODE *
talloc()
{
	auto	TNODE	*tx;
	tx = (TNODE *) emalloc( sizeof(TNODE), "talloc");
	return( tx );
}
shortwrite(fp,is)
FILE	*fp;
char	*is;
{
	static	char	os[FNMSIZ];
	REG		char	*isx = is;
	REG		char	*osx = os;
	auto	USHORT	dif;
	while(*osx != 0 && *osx == *isx)	{
		osx += 1;
		isx += 1;
		}
	strcpy(os,is);
	dif = isx - is;
	if(dif >= 2)	{
		dif += '@';
		putc(dif,fp);
		fputs(isx,fp);
		fputs("\n",fp);
		}
	else	{
		fputs(is,fp);
		fputs("\n",fp);
		}
	return(dif);
}
char	*
strvowel(is)
char	*is;
{
	REG		char	*isx = is;
	REG		char	*osx = is;
	while(*isx != 0)
	if(*isx == 'a' || *isx == 'e' ||
		 *isx == 'i' || *isx == 'o' || *isx == 'u')	isx += 1;
	else											*osx++ = *isx++;
	*osx = 0;
	return(is);
}
checkwrite(fp,is)
FILE	*fp;
char	*is;
{
	extern	long	crccode;
	crcinit();
	addbfcrc(is,strlen(is));
	fwrite( (char *) &crccode, sizeof(long), 1, fp);
	return(0);
}
char	*
skipdigit(is)
char	*is;
{
	while(isspace(*is))	++is;
	while(isdigit(*is))	++is;
	return(is);
}
