/*UNXLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	<signal.h>
#define		memnull(a,b)memset(a,0,b)
#define	CNTRD	'\004'
#define	CNTRDS	"\004"
typedef	struct	CHAIN	{
	char			*crud;
	struct	CHAIN	*next;
}	CHAIN;
CHAIN	*cb = NULL;
CHAIN	*cx = NULL;
CHAIN	*cz = NULL;
KENV	kenv;
char	*ob = NULL;
char	*cu_head="";
char	*cu_tail="";
long	fsize = 0L;				/* file size */
long	curtm = 0L;				/* elapsed time */
long	begtm = 0L;				/* starting time */
long	count = 0L;				/* characters sent */
long	cleft = 0L;				/* characters remaing */
long	time();
int		cu_nap = 0;
int		cu_char = 0;
int		cu_bloc = 0;
int		cu_alarm = 0;
extern	CHAIN	*chain();
extern	long	time();
extern	char	*wrhint();
CHAIN	*
chain(is)		/* make a chain of lines */
char	*is;
{
	cu_char += strlen(is);
	if((cu_char / BUFSIZ) >= cu_bloc)	return(NULL);
	cx = (CHAIN *) malloc( sizeof(CHAIN) );
	if(cx == NULL)			return(NULL);
	memnull( (char *) cx, sizeof(CHAIN) );
	cx->crud = strsave(is);
	if(cx->crud == NULL)	return(NULL);
	if(cb == NULL)			cb = cx;
	if(cz != NULL)			cz->next = cx;
	return(cz = cx);
}
char	*
unputs(is,fp)		/* write lines with delay */
char	*is;
FILE	*fp;
{
	register	char	*isx = is;
	register	FILE	*fpx = fp;
	auto		int	tin;
	tin = alarm(cu_alarm);
	while(*isx)	
	if(iseol(*isx))	{
		putc(*isx++,fpx);
		fflush(fpx);
		if(cu_nap)	nap((long) cu_nap);
		}
	else	putc(*isx++,fpx);
	alarm(tin);
	return(is);
}
unchain()
{
	register	CHAIN	*cx = cb;
	auto		int	ln;
	auto		int	rt;
	auto		int	nd;
	auto		int	pc;
	while(cx != NULL)	{
		if(cx->crud)
			unputs(cx->crud,stdout);
		count += (ln = strlen(cx->crud));
		cleft -= ln;
		fflush(stdout);
		free(cx);
		free(cx->crud);
		cx = cx->next;
	}
	{
		curtm = time(NULL) - begtm;
		curtm = curtm ? curtm : 1;
		rt = count / curtm;
		rt = rt ? rt : 1;
		nd = (cleft / rt);
		pc = (cleft * 100L) / fsize;
		if(kenv.report)	print("et %4ld ct %6ld rt %4d nd %4d pc %4d\n",
			curtm,count,rt,nd,pc);
	}
	cx = cb = cz = NULL;
	return(cu_char = 0);
}
cucat(fp)
FILE	*fp;
{
	auto	char	ls[BUFSIZ];
/**/
	fsize = cleft = filesize(getcfn());
	if(fsize <= 0L)	{
		errmsg("cucat <bad file> '%s'\n",getcfn());
		return(0);
		}
	count = 0L;
	fprintf(stderr,"%s\n",getcfn());
/**/
	header();
	begtm = time( (long *) NULL);
	while(fgets(ls,BUFSIZ-1,fp))	{
		if(!chain(ls))	{
			unchain();
			chain(ls);
			}
		}
	unchain();
	fputs("\n\004",stdout);
	fp = xfclose(fp);
	if(kenv.report)	print("\n  %ld %s\n",fsize,getcfn());
	trailer();
	return(0);
}
header()
{
	auto	char	*cfn = getcfn();
	fprintf(stdout,cu_head,cfn,cfn,cfn,cfn);
	fflush(stdout);
	sleep(10);
}
trailer()
{
	auto	char	*cfn = getcfn();
	fprintf(stdout,cu_tail,cfn,cfn,cfn,cfn);
	fflush(stdout);
}
void
terror(ty)
{
	trailer();
	exit(ty);
}
main(argc,argv)
int		argc;
char	*argv[];
{
	signal(SIGINT,terror);
#ifdef	MSDOS
	setsig((FUNCP) terror);
#else
	signal(SIGALRM,terror);
#endif
/**/
	disnme(kenv.pname = "cucat");
/**/
	disrec(cmdnum(argc,argv,'R',1,0));
/**/
	ob = emalloc(bufsiz(),"main");
	setbuf(stdout,ob);
/**/
	kenv.dosdos = isdos();
	if(!kenv.dosdos) telluser(kenv.pname);
/**/
	if(cmdnum(argc,argv,'h',0,1))	exit(hint(0));
/**/
	kenv.diagno = cmdnum(argc,argv,'D',0,DA);
/**/
	kenv.report = cmdnum(argc,argv,'r',0,DA);
/**/
	if(cmdnum(argc,argv,'d',0,1))	{
		auto	char	*dir;
		if(chdir(dir = cmdstr(argc,argv,'d',NULL)) < 0)	{
			prterr("%s",dir);
			terror(FUBAR);
			}
		}
/**/
	cu_nap = cmdnum(argc,argv,'p',10,10);
	cu_alarm = cmdnum(argc,argv,'a',30,30);
	cu_head = cmdstr(argc,argv,'H',NULL);
	cu_bloc = cmdnum(argc,argv,'B',20,20);
	xesc(cu_head);
	cu_tail = cmdstr(argc,argv,'T',NULL);
	xesc(cu_tail);
	if(cmdacc(argc,argv,04))		exit(FUBAR);
	dolist(argc,argv,cucat);
	if(cmdnum(argc,argv,'x',0,1))	puts("stty 0");
	exit(0);
}
/*NO_TABS*/
hint(ty)
int		ty;
{
static	char	*hx[] = {
"=",
"cucat [-options] [file(s)",
"=",
"-H ?   header string for file",
"-T ?   trailer string for file",
"-a?    alarm seconds",
"-d ?   directory for file",
"-p?    pause ?/1000 seconds",
"-r     report on transmission progress",
"-x?    hang up after last file",
"=",
}	;
	prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
	exit(ty);
}
/*TABS*/
#ifdef	MSDOS
#define	NAP
#endif
#ifdef	V29
#define	NAP
#endif
#ifdef	V42
#define	NAP
#endif
#ifdef	NAP
nap(ty)
{
	return(sleep(1));
}
#endif
#ifdef	NEW
dopipe()
{
	auto	char	ls[FNMSIZ];
	auto	char	ws[FNMSIZ];
	auto	char	wf[FNMSIZ];
	auto	FILE	*fp;
	strcpy(wf,"/usr/tmp/cuXXXXXX.tmp");
	maketemp(wf);
	while(fgetlf(ls,ls+BLKSIZ-1,stdin))	{
		strcnd(ws);
		sprintf(ws,"kencode.x -e < %s > %s",ls,wf);
		if(system(ws))	{
			errmsg("dopipe <failed> '%s'\n",ws);
			continue;
			}
		if(!(fp = efopen(wf,"r")))		continue;
		cucat(fp);
		fp = xfclose(fp);
		}
	return(0);
}
#endif




